您的位置:首页 > 其它

HDU 1704 (搜索题)

2010-05-01 11:53 337 查看

Rank

Time Limit: 1000/1000 MS (Java/Others) Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 450 Accepted Submission(s): 157


Problem Description
there are N ACMers in HDU team.
ZJPCPC Sunny Cup 2007 is coming, and lcy want to select some excellent ACMers to attend the contest. There have been M matches since the last few days(No two ACMers will meet each other at two matches, means between two ACMers there will be at most one match). lcy also asks"Who is the winner between A and B?" But sometimes you can't answer lcy's query, for example, there are 3 people, named A, B, C.and 1 match was held between A and B, in the match A is the winner, then if lcy asks "Who is the winner between A and B", of course you can answer "A", but if lcy ask "Who is the winner between A and C", you can't tell him the answer.
As lcy's assistant, you want to know how many queries at most you can't tell lcy(ask A B, and ask B A is the same; and lcy won't ask the same question twice).

Input
The input contains multiple test cases.
The first line has one integer,represent the number of test cases.
Each case first contains two integers N and M(N , M <= 500), N is the number of ACMers in HDU team, and M is the number of matchs have been held.The following M lines, each line means a match and it contains two integers A and B, means A wins the match between A and B.And we define that if A wins B, and B wins C, then A wins C.

Output
For each test case, output a integer which represent the max possible number of queries that you can't tell lcy.

Sample Input

3
3 3
1 2
1 3
2 3
3 2
1 2
2 3
4 2
1 2
3 4


Sample Output

0
0
4

Hint
in the case3, if lcy ask (1 3 or 3 1) (1 4 or 4 1) (2 3 or 3 2) (2 4 or 4 2), then you can't tell him who is the winner.
思路:搜索题。定义一个二维数组,初始化0,但是一个对角线要赋值1,能分出胜负的赋值1,然后计算下1的个数num,最后num要记得减去n,以为本身对本身不算,即:num-=n;总的可能个数为sum=1+2+...+n;所以最后为sum-num.代码如下:
#include <stdio.h>
#include <string.h>
int a[505][505];
int t,n,m;

void DFS(int p,int q)
{
int i,j;
for(i=1;i<=n;i++)
{
if(a[i][p]==1)
{
a[i][q]=1;
for(j=1;j<=n;j++)
{
if(a[q][j]==1)
a[i][j]=1;
}
}
}
}

int main()
{
int x,y,i,j,sum,num;
scanf("%d",&t);
while(t--)
{
sum=num=0;
memset(a,0,sizeof(a));
scanf("%d%d",&n,&m);
for(i=1;i<=n;i++)
a[i][i]=1;
while(m--)
{
scanf("%d%d",&x,&y);
a[x][y]=1;
DFS(x,y);
}
for(i=1;i<=n;i++)
{
for(j=1;j<=n;j++)
{
if(a[i][j]==1)
num++;
}
}
num-=n;
for(i=1;i<=n-1;i++)
sum+=i;
printf("%d/n",sum-num);
}
return 0;
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: